#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Chars.h"
#include "Print.h"
#include "Knife.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(Vram + VramRowSize * 1 + 30, "SCORE"); 
    PrintS(Vram + VramRowSize * 4 + 30, "HIGH");
    PrintS(Vram + VramRowSize * 5 + 30, "SCORE"); 
    PrintS(Vram + VramRowSize * 8 + 30, "STAGE");
    PrintByteNumber2(Vram + VramRowSize * 9 + 34, CurrentStage + 1);
    PrintS(Vram + VramRowSize * 11 + 30, "TIME");

    {
        constexpr ptr<byte> RemainLeft = Vram + VramRowSize * 21 + 30;
        ptr<byte> pVram;
        byte count;
        pVram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            Print2x2(pVram, Char_Man);
            pVram += 2;
        }
    }

    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + VramRowSize * 2 + 30, Score);
    PrintC(pVram, '0');

    pVram = PrintNumber5(Vram + VramRowSize * 6 + 30, HiScore);
    PrintC(pVram, '0');
}

void PrintTime()
{
    PrintNumber3(Vram + VramRowSize * 12 + 33, StageTime);
}

void PrintHeldKnives()
{
    ptr<byte> pVram;
    byte count, i;

    pVram = Vram + VramRowSize * 19 + 30;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        *pVram = 0xc4; ++pVram;
        ++i;
        --count;
    }
    while (i != 4) {
        *pVram = Char_Space; ++pVram;
        ++i;
    }
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 11 + 12, "GAME OVER");
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 11 + 13, "TIME UP");
}

void Title()
{
    ClearScreen(); 
    {
        static const byte[] TitleBytes = {
            //	M
            0xfa, 0xf7, 0xf7, 0xfd, 
            0xfa, 0xf5, 0xf5, 0xff, 
            0xfa, 0xf5, 0xf5, 0xff, 
            0xf2, 0xf1, 0xf1, 0xf3, 
            //	A
            0xf0, 0xfe, 0xfb, 0xf4, 
            0xfa, 0xf5, 0xf0, 0xff, 
            0xfa, 0xf7, 0xf3, 0xff, 
            0xf2, 0xf1, 0xf0, 0xf3, 
            //	Z
            0xf2, 0xf3, 0xfb, 0xf7, 
            0xf0, 0xf8, 0xf7, 0xf0, 
            0xf8, 0xf7, 0xf0, 0xf0, 
            0xf2, 0xf3, 0xf3, 0xf3, 
            //	Y
            0xfa, 0xf5, 0xfa, 0xf5, 
            0xf2, 0xfd, 0xfe, 0xf1, 
            0xf0, 0xfa, 0xf5, 0xf0, 
            0xf0, 0xf2, 0xf1, 0xf0, 
        };
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 1 + 8;
        p = TitleBytes;
        repeat (4) {
            repeat (4) {
                repeat (4) {
                    *pVram = *p; ++pVram;
                    ++p;
                }
                pVram += VramRowSize - 4 * VramStep;
            }
            pVram += 4 * VramStep - VramRowSize * 4;
        }
    }
    Print2x2(Vram + VramWidth * 8 + 8, Char_Man);
    Print2x2(Vram + VramWidth * 11 + 8, Char_Chaser);
    Print2x2(Vram + VramWidth * 14 + 8, Char_Disturber);
    Print2x2(Vram + VramWidth * 17 + 8, Char_Goal);
    
    PrintStatus(); 
    PrintS(Vram + VramWidth * 6 + 7, "--- CHARACTER ---");
    PrintS(Vram + VramWidth * 9 + 13, "MAN");
    PrintS(Vram + VramWidth * 12 + 13, "CHASER");
    PrintS(Vram + VramWidth * 15 + 13, "DISTURBER");
    PrintS(Vram + VramWidth * 18 + 13, "EXIT");

    PrintS(Vram + VramRowSize * 21 + 9, "PUSH SPACE KEY");
    PrintS(Vram + VramRowSize * 22 + 9, "OR CR KEY");
}
